# Fitovani rezonancni krivky ve vodivosti pomoci Gnuplotu
# pouziti v interaktivnim okne Gnuplotu: 
# load 'fit_resonance.gp' 
#
# Pred spustenim je treba nastavit vstupni parametery nize
# a pocatecin parametry fitu (rozumny odhad odecteny z grafu dat)

# Vstupni udaje k vyplneni
datsoubor='resonance.dat' # jmeno souboru s daty
nsf=1 # cislo sloupce s frekvencemi napeti v souboru
nsG=5 # cislo sloupce s vodivosti
nsPhi=6 # cislo sloupce s fazovym posunem

#definice funkci
# rezonancni krivka, vypocet amplitudy vodivosti
f(x) = G0/1e5/sqrt(((om0**2-x**2)/x/(alf2/10))**2+1)
# faze (deg)
phif(x) = atan((om0**2-x**2)/(x*alf2/10))*180/pi


#provedeni fitu
FIT_LIMIT = 1e-6
fit f(x) 'resonance.dat' using (column(nsf)*2*pi):(column(nsG)) via 'fit_resonance_start.par'

#vykresleni zavislosti vodivosti na uhlove frekvenci
set xlabel "{/Symbol w} (krad/s)"
set ylabel "G_0 (S)"
plot 'resonance.dat' using (column(nsf)*2*pi/1e3):(column(nsG)) w p ps 1.5 title 'data', \
  f(x*1e3) w l title 'fit'
#'resonance.dat' u ($1*2*pi):(f($1*2*pi)) w l title 'fit'

#ulozeni obrazku do souboru
set terminal png size 800,600 enhanced font "Helvetica" fontscale 2 \
  linewidth 2
set output 'fit3_G.png'
replot 
set terminal qt 0 font "Sans,12" linewidth 2
set output

print "* Zmacknout [Enter] pro pokracovani"
pause -1 # zmacknout enter k pokracovani

#vykresleni zavislosti faze na uhlove frekvenci
set xlabel "{/Symbol w} (krad/s)"
set ylabel "{/Symbol f} (°)"
plot 'resonance.dat' using (column(nsf)*2*pi/1e3):(column(nsPhi)) w p ps 1.5 title 'data', \
  phif(x*1e3) w l title 'fit'

#ulozeni obrazku do souboru
set terminal png size 800,600 enhanced font "Helvetica" fontscale 2 \
  linewidth 2
set output 'fit3_phi.png'
replot 
set terminal qt 0 font "Sans,12" linewidth 2
set output
